unit Grid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ImgList, ToolWin, ComCtrls,
  ActnList;

type
  TGridType = (gtNothing, gtSquare, gtHexH, gtHexV, gtDiamond, gtTriangle);
  TForm_Grid = class(TForm)
    L_Type01:     TLabel;
    G_ActionList: TActionList;
    G_ImageList:  TImageList;
    Grid_Nothing: TAction;
    Grid_Square:  TAction;
    Grid_HexH:    TAction;
    Grid_HexV:    TAction;
    Grid_Diamond: TAction;
    GridButtons:  TPanel;
    Btn_Nothing:  TSpeedButton;
    Btn_Square:   TSpeedButton;
    Btn_HexH:     TSpeedButton;
    Btn_HexV:     TSpeedButton;
    Btn_Diamond:  TSpeedButton;
    Check_Grid:   TCheckBox;

    Bevel1: TBevel;

    L_Size01: TLabel;
    L_Size02: TLabel;
    L_Size03: TLabel;
    L_Size04: TLabel;
    L_Size05: TLabel;
    E_SizeH:  TEdit;
    E_SizeV:  TEdit;

    L_Length02: TLabel;
    L_Length03: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;

    Bevel2: TBevel;

    L_Color01:  TLabel;
    L_Color02:  TLabel;
    L_Color03:  TLabel;
    L_Color04:  TLabel;
    ColorPanel: TPanel;
    ColorBarR:  TScrollBar;
    ColorBarG:  TScrollBar;
    ColorBarB:  TScrollBar;
    E_ColorR:   TEdit;
    E_ColorG:   TEdit;
    E_ColorB:   TEdit;

    Bevel3: TBevel;
    procedure KeyPressLimit(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure GridSizeChange(Sender: TObject);
    procedure ColorBarChange(Sender: TObject);
    procedure E_ColorChange(Sender: TObject);
    procedure Grid_NothingExecute(Sender: TObject);
    procedure Grid_SquareExecute(Sender: TObject);
    procedure Grid_HexHExecute(Sender: TObject);
    procedure Grid_HexVExecute(Sender: TObject);
    procedure Grid_DiamondExecute(Sender: TObject);
    procedure DrawGrid;
    procedure DrawSquare(_GWidth: Integer; _GHeight: Integer);
    procedure DrawHexH(_GWidth: Integer; _GHeight: Integer);
    procedure DrawHexV(_GWidth: Integer; _GHeight: Integer);
    procedure DrawDiamond(_GWidth: Integer; _GHeight: Integer);
  private
    { Private 錾 }
  public
    { Public 錾 }
    _CGrid: TBitmap; // Form_Canvas ̃Obh`p
    _GMode: TGridType; // I𒆂̃ObhE^Cv TGridType ́Œ`

    _GridW, _GridH: Integer; // Obhƍ
  end;

var
  Form_Grid: TForm_Grid;

implementation

uses Canvas, Palette;

{$R *.dfm}

procedure TForm_Grid.KeyPressLimit(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #08]) then // ̓L['0'`'9',BackSpace/Delete ȊOȂ
  begin
    Key := #0; // ͂𖳎
    beep;
  end;
end;

procedure TForm_Grid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form_Canvas.ToolButton1.Down := False; // Form_Canvasɂ\{^𐧌
end;

procedure TForm_Grid.FormCreate(Sender: TObject);
begin
  _CGrid := TBitmap.Create; // Obhprbg}bv
  _CGrid.Transparent := True; // 
  _CGrid.TransparentMode := tmFixed; // Fݒ͎wF

  _GMode := gtNothing; // ObhE^CvI{^̏Ԃɍ킹

  _GridW := StrToInt(E_SizeH.Text); // ObhEditBox̏Ԃɍ킹
  _GridH := StrToInt(E_SizeV.Text); // ObhEditBox̏Ԃɍ킹

  ColorBarChange(Sender);
end;

procedure TForm_Grid.GridSizeChange(Sender: TObject);
begin
  _GridW := StrToInt(E_SizeH.Text); // VObhIntegerŊm
  _GridH := StrToInt(E_SizeV.Text); // VObhIntegerŊm

  DrawGrid; // LoX̃ObhύX

  Form_Palette.GridLineDraw; // pbg̃ObhύX
  Form_Palette.FreeChip(Sender); // `bvI\
//  Form_Palette.ViewGrid1.OnExecute(Sender); // pbg̃Obh\
end;

procedure TForm_Grid.ColorBarChange(Sender: TObject);
var
  _R, _G, _B : Integer;
begin
  _R := ColorBarR.Position; // XN[o[̈ʒul
  _G := ColorBarG.Position;
  _B := ColorBarB.Position;

  ColorPanel.Color := RGB(_R, _G, _B); // \FύX

  E_ColorR.Text := IntToStr(_R); // EditBoxɔf
  E_ColorG.Text := IntToStr(_G);
  E_ColorB.Text := IntToStr(_B);

  DrawGrid; // LoX̃ObhύX

  Form_Palette.GridLineDraw; // pbg̃ObhύX
  Form_Palette.ViewGrid1.OnExecute(Sender); // pbg̃Obh\
end;

procedure TForm_Grid.E_ColorChange(Sender: TObject);
var
  _R, _G, _B : Integer;
begin
  if TEdit(Sender).Text = '' then
    TEdit(Sender).Text := '0'
  else if StrToInt(TEdit(Sender).Text) > 255 then
  begin
    TEdit(Sender).Text := '255';
    beep;
  end
  else
  begin
    _R := StrToInt(E_ColorR.Text); // EditBox̒ll
    _G := StrToInt(E_ColorG.Text);
    _B := StrToInt(E_ColorB.Text);

    ColorPanel.Color := RGB(_R, _G, _B); // \FύX

    ColorBarR.Position := _R;
    ColorBarG.Position := _G;
    ColorBarB.Position := _B;
  end;
  DrawGrid; // LoX̃ObhύX

  Form_Palette.GridLineDraw; // pbg̃ObhύX
  Form_Palette.ViewGrid1.OnExecute(Sender); // pbg̃Obh\
end;

procedure TForm_Grid.Grid_NothingExecute(Sender: TObject);
begin
  _GMode := gtNothing; // ObhE^Cvw
  DrawGrid; // LoX̃ObhύX
end;

procedure TForm_Grid.Grid_SquareExecute(Sender: TObject);
begin
  _GMode := gtSquare;
  DrawGrid;
end;

procedure TForm_Grid.Grid_HexHExecute(Sender: TObject);
begin
  _GMode := gtHexH;
  DrawGrid;
end;

procedure TForm_Grid.Grid_HexVExecute(Sender: TObject);
begin
  _GMode := gtHexV;
  DrawGrid;
end;

procedure TForm_Grid.Grid_DiamondExecute(Sender: TObject);
begin
  _GMode := gtDiamond;
  DrawGrid;
end;

procedure TForm_Grid.DrawGrid;
var
  _PenColor : TColor;
  _Rect : TRect;
begin
  _Rect := Rect(0, 0,
    Form_Canvas.C_Canvas.Width, Form_Canvas.C_Canvas.Height); // 摜̈ݒ

  _PenColor := Form_Grid.ColorPanel.Color; // Obh{Fm

  with _CGrid do // Obh`̓ꊇ
  begin
    Width  := Form_Canvas.C_Canvas.Width;  // `̈敝ݒ
    Height := Form_Canvas.C_Canvas.Height; // `̈捂ݒ

    Canvas.Brush.Color := $FFFFFF // ObhFƕKقȂFɂȂ悤
      xor _PenColor; // hԂFObhF̔]F
    Canvas.FillRect(_Rect); // ShԂ
    TransparentColor := Canvas.Brush.Color; // hԂF𓧖FɎw

    Canvas.Pen.Color := _PenColor; // Obh̐Fl

    case _GMode of // w肳ꂽ`̃Obh`
      gtSquare:  DrawSquare (_GridW, _GridH);
      gtHexH:    DrawHexH   (_GridW, _GridH);
      gtHexV:    DrawHexV   (_GridW, _GridH);
      gtDiamond: DrawDiamond(_GridW, _GridH);
    else
      begin
        SetLength(Form_Canvas._ChipArray,    1); // `bvzu
        SetLength(Form_Canvas._ChipArray[0], 1);
      end;
    end;
  end;

  Form_Canvas.CompoundLayer;
{
  with Form_Canvas.C_Canvas.Canvas do // LoX\
  begin
    CopyMode := cmSrcCopy; // ObhȂ摜̂܂
    CopyRect(_Rect, Form_Canvas._NoGrid.Canvas, _Rect); // LoXɃRs[

    Draw(0, 0, _CGrid); // Obh摜㏑
  end;
}
end;

procedure TForm_Grid.DrawSquare(_GWidth: Integer; _GHeight: Integer);
var
  _H, _V : Integer;
  _x, _y : Integer;
  _i     : Integer;
begin
  with _CGrid do // Obh\pIuWFNg̏ꊇ
  begin
    _H := Trunc(Width  / _GWidth ) + 1; // ̌JԂ 
    _V := Trunc(Height / _GHeight) + 1; // ̌JԂ 

    for _i := 1 to _H do // 
    begin
      _x := _i * _GWidth - 1;
      Canvas.MoveTo(_x, 0);
      Canvas.LineTo(_x, Height);
    end;
    for _i := 1 to _V do // 
    begin
      _y := _i * _GHeight - 1;
      Canvas.MoveTo(0,     _y);
      Canvas.LineTo(Width, _y);
    end;
  end;

    SetLength(Form_Canvas._ChipArray, _H - 1); // `bvpz
  for _i := 0 to _H - 2 do
    SetLength(Form_Canvas._ChipArray[_i], _V - 1);
end;

procedure TForm_Grid.DrawHexH(_GWidth: Integer; _GHeight: Integer);
var
  _Wsqrt3 : Single;

  _X : array[0..2] of Integer;
  _Y : array[0..4] of Integer;

  _H,  _V  : Integer;
  _xx, _yy : Integer;
  _i,  _j  : Integer;
begin
  _Wsqrt3 := _GWidth * 0.25 * sqrt(3);

  _X[0] := Trunc(_GWidth * 0.5 - _Wsqrt3 + 0.5); // AutoREALM ̃Obh`Ql
  _X[1] := Trunc(_GWidth * 0.5 + 0.5);
  _X[2] := Trunc(_GWidth * 0.5 + _Wsqrt3 + 0.5); //     1,0
                                                 // 0,1 ^_ 2,1
  _Y[0] := 0;                                    //    b
  _Y[1] := Trunc(_GHeight * 0.25 + 0.5);         // 0,2 _^ 2,2
  _Y[2] := Trunc(_GHeight * 0.75 + 0.5);         //     1,3
  _Y[3] := _GHeight;                             //      b
  _Y[4] := Trunc(_GHeight * 1.5 + 0.5);          //     1,4

  _H := Trunc(_CGrid.Width / _WSqrt3 / 2); // JԂ 
  _V := Trunc((_CGrid.Height - _GHeight) / _GHeight / 1.5) + 1; // JԂ 

  for _j := 0 to _V do // ɌJԂ
  begin
    _yy := Trunc(_j * _GHeight * 1.5 + 0.5);
    for _i := 0 to _H do // ɌJԂ
    begin
      _xx := Trunc(_i * _Wsqrt3 * 2 - _GWidth * 0.5 + _Wsqrt3 + 0.5) - 1;
      _CGrid.Canvas.Polyline([
        Point(_X[2] + _xx, _Y[1] + _yy), // iN_
        Point(_X[1] + _xx, _Y[0] + _yy), // E
        Point(_X[0] + _xx, _Y[1] + _yy), // 
        Point(_X[0] + _xx, _Y[2] + _yy), // 
        Point(_X[1] + _xx, _Y[3] + _yy), // 
        Point(_X[2] + _xx, _Y[2] + _yy)]); // E
      _CGrid.Canvas.MoveTo(_X[1] + _xx, _Y[3] + _yy); // iN_
      _CGrid.Canvas.LineTo(_X[1] + _xx, _Y[4] + _yy); // 
    end;
  end;

  _j := Trunc((_CGrid.Height - _GHeight) / _GHeight / 0.75) + 1;
    SetLength(Form_Canvas._ChipArray, _H); // `bvpz
  for _i := 0 to _H - 2 do
    SetLength(Form_Canvas._ChipArray[_i], _j);
end;

procedure TForm_Grid.DrawHexV(_GWidth: Integer; _GHeight: Integer);
var
  _Hsqrt3 : Single;

  _X : array[0..4] of Integer;
  _Y : array[0..3] of Integer;

  _H,  _V  : Integer;
  _xx, _yy : Integer;
  _i,  _j  : Integer;
begin
  _Hsqrt3 := _GHeight * 0.25 * sqrt(3); // DrawHexH ̐Ɛւ

  _X[0] := 0;
  _X[1] := Trunc(_GWidth * 0.25 + 0.5);
  _X[2] := Trunc(_GWidth * 0.75 + 0.5);
  _X[3] := _GWidth;
  _X[4] := Trunc(_GWidth * 1.5 + 0.5);

  _Y[0] := Trunc(_GHeight * 0.5 - _Hsqrt3 + 0.5);
  _Y[1] := Trunc(_GHeight * 0.5 + 0.5);
  _Y[2] := Trunc(_GHeight * 0.5 + _Hsqrt3 + 0.5);
  _Y[3] := Trunc(_Hsqrt3 + 0.5);

  _H := Trunc((_CGrid.Width - _GWidth) / _GWidth / 1.5) + 1; // JԂ 
  _V := Trunc(_CGrid.Height / _HSqrt3 / 2); // JԂ 

  for _j := 0 to _H do // ɌJԂ
  begin
    _xx := Trunc(_j * _GWidth * 1.5 + 0.5);
    for _i := 0 to _V do // ɌJԂ
    begin
      _yy := Trunc(_i * _Hsqrt3 * 2 - _GHeight * 0.5 + _Hsqrt3 + 0.5) - 1;
      _CGrid.Canvas.Polyline([
        Point(_X[1] + _xx, _Y[2] + _yy), // sN_
        Point(_X[0] + _xx, _Y[1] + _yy), // 
        Point(_X[1] + _xx, _Y[0] + _yy), // 
        Point(_X[2] + _xx, _Y[0] + _yy), // 㒆
        Point(_X[3] + _xx, _Y[1] + _yy), // E
        Point(_X[2] + _xx, _Y[2] + _yy)]); // E
      _CGrid.Canvas.MoveTo(_X[3] + _xx, _Y[1] + _yy); // sN_
      _CGrid.Canvas.LineTo(_X[4] + _xx, _Y[1] + _yy); // E
    end;
  end;

  _j := Trunc((_CGrid.Width - _GWidth) / _GWidth / 0.75) + 1;
    SetLength(Form_Canvas._ChipArray, _j); // `bvpz
  for _i := 0 to _j - 1 do
    SetLength(Form_Canvas._ChipArray[_i], _V);
end;

procedure TForm_Grid.DrawDiamond(_GWidth: Integer; _GHeight: Integer);
var
  _H,  _V  : Integer;
  _X,  _Y  : Integer;
  _xx, _yy : Integer;

  _i: Integer;
begin
  _H := Trunc((_CGrid.Width  - (_GWidth  / 2)) / _GWidth ) + 1;
  _V := Trunc((_CGrid.Height - (_GHeight / 2)) / _GHeight) + 1;

  _X := (_H + 1) * _GWidth;
  _Y := (_V + 1) * _GHeight;

  _xx := Trunc(_GWidth  / 2 + 0.5);
  _yy := Trunc(_GHeight / 2 + 0.5);

  for _i := 0 to _H do 
  begin
    _CGrid.Canvas.MoveTo(_xx + _GWidth * (_i + _V + 1), _Y); // _ tXbVi㔼j
    _CGrid.Canvas.LineTo(_xx + _GWidth *  _i, 0);

//    _CGrid.Canvas.MoveTo(_xx + _GWidth *  _i, 0); // ^ XbVi㔼j
    _CGrid.Canvas.LineTo(0, _yy + _GHeight * _i);
  end;
  for _i := 0 to _V do 
  begin
    _CGrid.Canvas.MoveTo(0,  _yy + _GHeight *  _i); // _ tXbVij
    _CGrid.Canvas.LineTo(_X, _yy + _GHeight * (_H + 1 + _i));

    _CGrid.Canvas.MoveTo(_X, _yy + _GHeight * (_V - _i)); // ^ XbVij
    _CGrid.Canvas.LineTo(_xx + _GWidth * (_H - _i), _Y);
  end;

    SetLength(Form_Canvas._ChipArray, _H - 1); // `bvpz
  for _i := 0 to _H - 2 do
    SetLength(Form_Canvas._ChipArray[_i], _V - 1); // sSB
end;

end.
